<?php

namespace FiloBlu\CegidY2\Api\CustomerWcfService\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfUserDefinedValue ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: q39:ArrayOfUserDefinedValue
 * @subpackage Arrays
 */
class ArrayOfUserDefinedValue extends AbstractStructArrayBase
{
    /**
     * The UserDefinedValue
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedValue[]
     */
    public $UserDefinedValue;
    /**
     * Constructor method for ArrayOfUserDefinedValue
     * @uses ArrayOfUserDefinedValue::setUserDefinedValue()
     * @param \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedValue[] $userDefinedValue
     */
    public function __construct(array $userDefinedValue = array())
    {
        $this
            ->setUserDefinedValue($userDefinedValue);
    }
    /**
     * Get UserDefinedValue value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedValue[]|null
     */
    public function getUserDefinedValue()
    {
        return isset($this->UserDefinedValue) ? $this->UserDefinedValue : null;
    }
    /**
     * This method is responsible for validating the values passed to the setUserDefinedValue method
     * This method is willingly generated in order to preserve the one-line inline validation within the setUserDefinedValue method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateUserDefinedValueForArrayConstraintsFromSetUserDefinedValue(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfUserDefinedValueUserDefinedValueItem) {
            // validation for constraint: itemType
            if (!$arrayOfUserDefinedValueUserDefinedValueItem instanceof \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedValue) {
                $invalidValues[] = is_object($arrayOfUserDefinedValueUserDefinedValueItem) ? get_class($arrayOfUserDefinedValueUserDefinedValueItem) : sprintf('%s(%s)', gettype($arrayOfUserDefinedValueUserDefinedValueItem), var_export($arrayOfUserDefinedValueUserDefinedValueItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The UserDefinedValue property can only contain items of type \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedValue, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set UserDefinedValue value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedValue[] $userDefinedValue
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\ArrayType\ArrayOfUserDefinedValue
     */
    public function setUserDefinedValue(array $userDefinedValue = array())
    {
        // validation for constraint: array
        if ('' !== ($userDefinedValueArrayErrorMessage = self::validateUserDefinedValueForArrayConstraintsFromSetUserDefinedValue($userDefinedValue))) {
            throw new \InvalidArgumentException($userDefinedValueArrayErrorMessage, __LINE__);
        }
        if (is_null($userDefinedValue) || (is_array($userDefinedValue) && empty($userDefinedValue))) {
            unset($this->UserDefinedValue);
        } else {
            $this->UserDefinedValue = $userDefinedValue;
        }
        return $this;
    }
    /**
     * Add item to UserDefinedValue value
     * @throws \InvalidArgumentException
     * @param \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedValue $item
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\ArrayType\ArrayOfUserDefinedValue
     */
    public function addToUserDefinedValue(\FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedValue $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedValue) {
            throw new \InvalidArgumentException(sprintf('The UserDefinedValue property can only contain items of type \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedValue, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->UserDefinedValue[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedValue|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedValue|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedValue|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedValue|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedValue|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string UserDefinedValue
     */
    public function getAttributeName()
    {
        return 'UserDefinedValue';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\ArrayType\ArrayOfUserDefinedValue
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
