<?php

namespace FiloBlu\CegidY2\Api\CustomerWcfService\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfUserField ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: q45:ArrayOfUserField
 * @subpackage Arrays
 */
class ArrayOfUserField extends AbstractStructArrayBase
{
    /**
     * The UserField
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserField[]
     */
    public $UserField;
    /**
     * Constructor method for ArrayOfUserField
     * @uses ArrayOfUserField::setUserField()
     * @param \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserField[] $userField
     */
    public function __construct(array $userField = array())
    {
        $this
            ->setUserField($userField);
    }
    /**
     * Get UserField value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserField[]|null
     */
    public function getUserField()
    {
        return isset($this->UserField) ? $this->UserField : null;
    }
    /**
     * This method is responsible for validating the values passed to the setUserField method
     * This method is willingly generated in order to preserve the one-line inline validation within the setUserField method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateUserFieldForArrayConstraintsFromSetUserField(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfUserFieldUserFieldItem) {
            // validation for constraint: itemType
            if (!$arrayOfUserFieldUserFieldItem instanceof \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserField) {
                $invalidValues[] = is_object($arrayOfUserFieldUserFieldItem) ? get_class($arrayOfUserFieldUserFieldItem) : sprintf('%s(%s)', gettype($arrayOfUserFieldUserFieldItem), var_export($arrayOfUserFieldUserFieldItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The UserField property can only contain items of type \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserField, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set UserField value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserField[] $userField
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\ArrayType\ArrayOfUserField
     */
    public function setUserField(array $userField = array())
    {
        // validation for constraint: array
        if ('' !== ($userFieldArrayErrorMessage = self::validateUserFieldForArrayConstraintsFromSetUserField($userField))) {
            throw new \InvalidArgumentException($userFieldArrayErrorMessage, __LINE__);
        }
        if (is_null($userField) || (is_array($userField) && empty($userField))) {
            unset($this->UserField);
        } else {
            $this->UserField = $userField;
        }
        return $this;
    }
    /**
     * Add item to UserField value
     * @throws \InvalidArgumentException
     * @param \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserField $item
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\ArrayType\ArrayOfUserField
     */
    public function addToUserField(\FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserField $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserField) {
            throw new \InvalidArgumentException(sprintf('The UserField property can only contain items of type \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserField, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->UserField[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserField|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserField|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserField|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserField|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserField|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string UserField
     */
    public function getAttributeName()
    {
        return 'UserField';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\ArrayType\ArrayOfUserField
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
