<?php

namespace FiloBlu\CegidY2\Api\CustomerWcfService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AddNewCustomer StructType
 * Meta information extracted from the WSDL
 * - documentation: Permet la création d'un client. Son numéro sera attribué automatiquement (nécessite l'activation de la numérotation automatique sur l'établissement de l'utilisateur)
 * @subpackage Structs
 */
class AddNewCustomer extends AbstractStructBase
{
    /**
     * The customerData
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerInsertData
     */
    public $customerData;
    /**
     * The clientContext
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\RetailContext
     */
    public $clientContext;
    /**
     * Constructor method for AddNewCustomer
     * @uses AddNewCustomer::setCustomerData()
     * @uses AddNewCustomer::setClientContext()
     * @param \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerInsertData $customerData
     * @param \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\RetailContext $clientContext
     */
    public function __construct(\FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerInsertData $customerData = null, \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\RetailContext $clientContext = null)
    {
        $this
            ->setCustomerData($customerData)
            ->setClientContext($clientContext);
    }
    /**
     * Get customerData value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerInsertData|null
     */
    public function getCustomerData()
    {
        return isset($this->customerData) ? $this->customerData : null;
    }
    /**
     * Set customerData value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerInsertData $customerData
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\AddNewCustomer
     */
    public function setCustomerData(\FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerInsertData $customerData = null)
    {
        if (is_null($customerData) || (is_array($customerData) && empty($customerData))) {
            unset($this->customerData);
        } else {
            $this->customerData = $customerData;
        }
        return $this;
    }
    /**
     * Get clientContext value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\RetailContext|null
     */
    public function getClientContext()
    {
        return isset($this->clientContext) ? $this->clientContext : null;
    }
    /**
     * Set clientContext value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\RetailContext $clientContext
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\AddNewCustomer
     */
    public function setClientContext(\FiloBlu\CegidY2\Api\CustomerWcfService\StructType\RetailContext $clientContext = null)
    {
        if (is_null($clientContext) || (is_array($clientContext) && empty($clientContext))) {
            unset($this->clientContext);
        } else {
            $this->clientContext = $clientContext;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\AddNewCustomer
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
