<?php

namespace FiloBlu\CegidY2\Api\CustomerWcfService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AddNewCustomerResponse StructType
 * Meta information extracted from the WSDL
 * - documentation: Permet la création d'un client. Son numéro sera attribué automatiquement (nécessite l'activation de la numérotation automatique sur l'établissement de l'utilisateur)
 * @subpackage Structs
 */
class AddNewCustomerResponse extends AbstractStructBase
{
    /**
     * The AddNewCustomerResult
     * Meta information extracted from the WSDL
     * - documentation: Renvoie l'identifiant du client créé.
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $AddNewCustomerResult;
    /**
     * Constructor method for AddNewCustomerResponse
     * @uses AddNewCustomerResponse::setAddNewCustomerResult()
     * @param string $addNewCustomerResult
     */
    public function __construct($addNewCustomerResult = null)
    {
        $this
            ->setAddNewCustomerResult($addNewCustomerResult);
    }
    /**
     * Get AddNewCustomerResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAddNewCustomerResult()
    {
        return isset($this->AddNewCustomerResult) ? $this->AddNewCustomerResult : null;
    }
    /**
     * Set AddNewCustomerResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $addNewCustomerResult
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\AddNewCustomerResponse
     */
    public function setAddNewCustomerResult($addNewCustomerResult = null)
    {
        // validation for constraint: string
        if (!is_null($addNewCustomerResult) && !is_string($addNewCustomerResult)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($addNewCustomerResult, true), gettype($addNewCustomerResult)), __LINE__);
        }
        if (is_null($addNewCustomerResult) || (is_array($addNewCustomerResult) && empty($addNewCustomerResult))) {
            unset($this->AddNewCustomerResult);
        } else {
            $this->AddNewCustomerResult = $addNewCustomerResult;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\AddNewCustomerResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
