<?php

namespace FiloBlu\CegidY2\Api\CustomerWcfService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SearchCustomerIds StructType
 * Meta information extracted from the WSDL
 * - documentation: Renvoie la liste des clients vérifiant les critères de recherche présents dans l'objet passé en paramètre d'entrée.
 * @subpackage Structs
 */
class SearchCustomerIds extends AbstractStructBase
{
    /**
     * The searchData
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerSearchDataType
     */
    public $searchData;
    /**
     * The clientContext
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\RetailContext
     */
    public $clientContext;
    /**
     * Constructor method for SearchCustomerIds
     * @uses SearchCustomerIds::setSearchData()
     * @uses SearchCustomerIds::setClientContext()
     * @param \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerSearchDataType $searchData
     * @param \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\RetailContext $clientContext
     */
    public function __construct(\FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerSearchDataType $searchData = null, \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\RetailContext $clientContext = null)
    {
        $this
            ->setSearchData($searchData)
            ->setClientContext($clientContext);
    }
    /**
     * Get searchData value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerSearchDataType|null
     */
    public function getSearchData()
    {
        return isset($this->searchData) ? $this->searchData : null;
    }
    /**
     * Set searchData value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerSearchDataType $searchData
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\SearchCustomerIds
     */
    public function setSearchData(\FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerSearchDataType $searchData = null)
    {
        if (is_null($searchData) || (is_array($searchData) && empty($searchData))) {
            unset($this->searchData);
        } else {
            $this->searchData = $searchData;
        }
        return $this;
    }
    /**
     * Get clientContext value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\RetailContext|null
     */
    public function getClientContext()
    {
        return isset($this->clientContext) ? $this->clientContext : null;
    }
    /**
     * Set clientContext value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\RetailContext $clientContext
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\SearchCustomerIds
     */
    public function setClientContext(\FiloBlu\CegidY2\Api\CustomerWcfService\StructType\RetailContext $clientContext = null)
    {
        if (is_null($clientContext) || (is_array($clientContext) && empty($clientContext))) {
            unset($this->clientContext);
        } else {
            $this->clientContext = $clientContext;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\SearchCustomerIds
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
