<?php

namespace FiloBlu\CegidY2\Api\ItemInventoryWcfService\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfItemIdentifier ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfItemIdentifier
 * @subpackage Arrays
 */
class ArrayOfItemIdentifier extends AbstractStructArrayBase
{
    /**
     * The ItemIdentifier
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\ItemIdentifier[]
     */
    public $ItemIdentifier;
    /**
     * Constructor method for ArrayOfItemIdentifier
     * @uses ArrayOfItemIdentifier::setItemIdentifier()
     * @param \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\ItemIdentifier[] $itemIdentifier
     */
    public function __construct(array $itemIdentifier = array())
    {
        $this
            ->setItemIdentifier($itemIdentifier);
    }
    /**
     * Get ItemIdentifier value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\ItemIdentifier[]|null
     */
    public function getItemIdentifier()
    {
        return isset($this->ItemIdentifier) ? $this->ItemIdentifier : null;
    }
    /**
     * This method is responsible for validating the values passed to the setItemIdentifier method
     * This method is willingly generated in order to preserve the one-line inline validation within the setItemIdentifier method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateItemIdentifierForArrayConstraintsFromSetItemIdentifier(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfItemIdentifierItemIdentifierItem) {
            // validation for constraint: itemType
            if (!$arrayOfItemIdentifierItemIdentifierItem instanceof \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\ItemIdentifier) {
                $invalidValues[] = is_object($arrayOfItemIdentifierItemIdentifierItem) ? get_class($arrayOfItemIdentifierItemIdentifierItem) : sprintf('%s(%s)', gettype($arrayOfItemIdentifierItemIdentifierItem), var_export($arrayOfItemIdentifierItemIdentifierItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ItemIdentifier property can only contain items of type \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\ItemIdentifier, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ItemIdentifier value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\ItemIdentifier[] $itemIdentifier
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\ArrayType\ArrayOfItemIdentifier
     */
    public function setItemIdentifier(array $itemIdentifier = array())
    {
        // validation for constraint: array
        if ('' !== ($itemIdentifierArrayErrorMessage = self::validateItemIdentifierForArrayConstraintsFromSetItemIdentifier($itemIdentifier))) {
            throw new \InvalidArgumentException($itemIdentifierArrayErrorMessage, __LINE__);
        }
        if (is_null($itemIdentifier) || (is_array($itemIdentifier) && empty($itemIdentifier))) {
            unset($this->ItemIdentifier);
        } else {
            $this->ItemIdentifier = $itemIdentifier;
        }
        return $this;
    }
    /**
     * Add item to ItemIdentifier value
     * @throws \InvalidArgumentException
     * @param \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\ItemIdentifier $item
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\ArrayType\ArrayOfItemIdentifier
     */
    public function addToItemIdentifier(\FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\ItemIdentifier $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\ItemIdentifier) {
            throw new \InvalidArgumentException(sprintf('The ItemIdentifier property can only contain items of type \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\ItemIdentifier, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ItemIdentifier[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\ItemIdentifier|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\ItemIdentifier|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\ItemIdentifier|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\ItemIdentifier|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\ItemIdentifier|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ItemIdentifier
     */
    public function getAttributeName()
    {
        return 'ItemIdentifier';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\ArrayType\ArrayOfItemIdentifier
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
