<?php

namespace FiloBlu\CegidY2\Api\ItemInventoryWcfService\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfStoreAvailableQty ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfStoreAvailableQty
 * @subpackage Arrays
 */
class ArrayOfStoreAvailableQty extends AbstractStructArrayBase
{
    /**
     * The StoreAvailableQty
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\StoreAvailableQty[]
     */
    public $StoreAvailableQty;
    /**
     * Constructor method for ArrayOfStoreAvailableQty
     * @uses ArrayOfStoreAvailableQty::setStoreAvailableQty()
     * @param \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\StoreAvailableQty[] $storeAvailableQty
     */
    public function __construct(array $storeAvailableQty = array())
    {
        $this
            ->setStoreAvailableQty($storeAvailableQty);
    }
    /**
     * Get StoreAvailableQty value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\StoreAvailableQty[]|null
     */
    public function getStoreAvailableQty()
    {
        return isset($this->StoreAvailableQty) ? $this->StoreAvailableQty : null;
    }
    /**
     * This method is responsible for validating the values passed to the setStoreAvailableQty method
     * This method is willingly generated in order to preserve the one-line inline validation within the setStoreAvailableQty method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateStoreAvailableQtyForArrayConstraintsFromSetStoreAvailableQty(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfStoreAvailableQtyStoreAvailableQtyItem) {
            // validation for constraint: itemType
            if (!$arrayOfStoreAvailableQtyStoreAvailableQtyItem instanceof \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\StoreAvailableQty) {
                $invalidValues[] = is_object($arrayOfStoreAvailableQtyStoreAvailableQtyItem) ? get_class($arrayOfStoreAvailableQtyStoreAvailableQtyItem) : sprintf('%s(%s)', gettype($arrayOfStoreAvailableQtyStoreAvailableQtyItem), var_export($arrayOfStoreAvailableQtyStoreAvailableQtyItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The StoreAvailableQty property can only contain items of type \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\StoreAvailableQty, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set StoreAvailableQty value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\StoreAvailableQty[] $storeAvailableQty
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\ArrayType\ArrayOfStoreAvailableQty
     */
    public function setStoreAvailableQty(array $storeAvailableQty = array())
    {
        // validation for constraint: array
        if ('' !== ($storeAvailableQtyArrayErrorMessage = self::validateStoreAvailableQtyForArrayConstraintsFromSetStoreAvailableQty($storeAvailableQty))) {
            throw new \InvalidArgumentException($storeAvailableQtyArrayErrorMessage, __LINE__);
        }
        if (is_null($storeAvailableQty) || (is_array($storeAvailableQty) && empty($storeAvailableQty))) {
            unset($this->StoreAvailableQty);
        } else {
            $this->StoreAvailableQty = $storeAvailableQty;
        }
        return $this;
    }
    /**
     * Add item to StoreAvailableQty value
     * @throws \InvalidArgumentException
     * @param \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\StoreAvailableQty $item
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\ArrayType\ArrayOfStoreAvailableQty
     */
    public function addToStoreAvailableQty(\FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\StoreAvailableQty $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\StoreAvailableQty) {
            throw new \InvalidArgumentException(sprintf('The StoreAvailableQty property can only contain items of type \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\StoreAvailableQty, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->StoreAvailableQty[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\StoreAvailableQty|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\StoreAvailableQty|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\StoreAvailableQty|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\StoreAvailableQty|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\StoreAvailableQty|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string StoreAvailableQty
     */
    public function getAttributeName()
    {
        return 'StoreAvailableQty';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\ArrayType\ArrayOfStoreAvailableQty
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
