<?php

namespace FiloBlu\CegidY2\Api\ItemInventoryWcfService\ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Update ServiceType
 * @subpackage Services
 */
class Update extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named UpdateShoppingCart
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2013/08 - V1105] - Permet la mise à jour différentielle de la quantité "panier web" d'un article pour un dépôt donné.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\UpdateShoppingCart $parameters
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\UpdateShoppingCartResponse|bool
     */
    public function UpdateShoppingCart(\FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\UpdateShoppingCart $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->UpdateShoppingCart($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\UpdateShoppingCartResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
