<?php

namespace FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AvailableQtyByItemByStore StructType
 * Meta information extracted from the WSDL
 * - documentation: Pour un article : la liste des boutiques et leur stock
 * - nillable: true
 * - type: tns:AvailableQtyByItemByStore
 * @subpackage Structs
 */
class AvailableQtyByItemByStore extends AbstractStructBase
{
    /**
     * The ItemCode
     * Meta information extracted from the WSDL
     * - documentation: Code de l'article.
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ItemCode;
    /**
     * The StoresAvailableQty
     * Meta information extracted from the WSDL
     * - documentation: Liste des stocks par magasin.
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\ItemInventoryWcfService\ArrayType\ArrayOfStoreAvailableQty
     */
    public $StoresAvailableQty;
    /**
     * Constructor method for AvailableQtyByItemByStore
     * @uses AvailableQtyByItemByStore::setItemCode()
     * @uses AvailableQtyByItemByStore::setStoresAvailableQty()
     * @param string $itemCode
     * @param \FiloBlu\CegidY2\Api\ItemInventoryWcfService\ArrayType\ArrayOfStoreAvailableQty $storesAvailableQty
     */
    public function __construct($itemCode = null, \FiloBlu\CegidY2\Api\ItemInventoryWcfService\ArrayType\ArrayOfStoreAvailableQty $storesAvailableQty = null)
    {
        $this
            ->setItemCode($itemCode)
            ->setStoresAvailableQty($storesAvailableQty);
    }
    /**
     * Get ItemCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getItemCode()
    {
        return isset($this->ItemCode) ? $this->ItemCode : null;
    }
    /**
     * Set ItemCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $itemCode
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\AvailableQtyByItemByStore
     */
    public function setItemCode($itemCode = null)
    {
        // validation for constraint: string
        if (!is_null($itemCode) && !is_string($itemCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($itemCode, true), gettype($itemCode)), __LINE__);
        }
        if (is_null($itemCode) || (is_array($itemCode) && empty($itemCode))) {
            unset($this->ItemCode);
        } else {
            $this->ItemCode = $itemCode;
        }
        return $this;
    }
    /**
     * Get StoresAvailableQty value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\ArrayType\ArrayOfStoreAvailableQty|null
     */
    public function getStoresAvailableQty()
    {
        return isset($this->StoresAvailableQty) ? $this->StoresAvailableQty : null;
    }
    /**
     * Set StoresAvailableQty value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\ItemInventoryWcfService\ArrayType\ArrayOfStoreAvailableQty $storesAvailableQty
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\AvailableQtyByItemByStore
     */
    public function setStoresAvailableQty(\FiloBlu\CegidY2\Api\ItemInventoryWcfService\ArrayType\ArrayOfStoreAvailableQty $storesAvailableQty = null)
    {
        if (is_null($storesAvailableQty) || (is_array($storesAvailableQty) && empty($storesAvailableQty))) {
            unset($this->StoresAvailableQty);
        } else {
            $this->StoresAvailableQty = $storesAvailableQty;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\AvailableQtyByItemByStore
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
