<?php

namespace FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AvailableQtyByStore StructType
 * Meta information extracted from the WSDL
 * - documentation: Objet, type couple, contenant une quantité disponible et l'identifant de l'établissement, dont le dépôt principal a été choisi pour le calcul du stock.
 * - nillable: true
 * - type: tns:AvailableQtyByStore
 * @subpackage Structs
 */
class AvailableQtyByStore extends AbstractStructBase
{
    /**
     * The AvailableQty
     * Meta information extracted from the WSDL
     * - documentation: Quantité disponible en stock de l’article déterminé. Si la référence article n’a pas permis de déterminer un identifiant article CBR, la quantité est renvoyée à 0. - Relatif à la colonne [DISPO.GQ_RESERVEFOU /
     * DISPO.GQ_ANNONCELIV / DISPO.GQ_ANNONCETRF / DISPO.GQ_PROPOACHAT / DISPO.GQ_PREPACLI / DISPO.GQ_DISPOCLI / DISPO.GQ_RESERVECLI / DISPO.GQ_RESERVETRF / DISPO.GQ_DEMRESERVECLI / DISPO.GQ_PANIERWEB].
     * - minOccurs: 0
     * @var float
     */
    public $AvailableQty;
    /**
     * The StoreDescription
     * Meta information extracted from the WSDL
     * - documentation: Identifiant de l’établissement dont le dépôt principal a été utilisé pour lire la quantité disponible. - Relatif à la colonne [ETABLISS.ET_LIBELLE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $StoreDescription;
    /**
     * The StoreId
     * Meta information extracted from the WSDL
     * - documentation: Libellé de l’établissement. - Relatif à la colonne [ETABLISS.ET_ETABLISSEMENT].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $StoreId;
    /**
     * Constructor method for AvailableQtyByStore
     * @uses AvailableQtyByStore::setAvailableQty()
     * @uses AvailableQtyByStore::setStoreDescription()
     * @uses AvailableQtyByStore::setStoreId()
     * @param float $availableQty
     * @param string $storeDescription
     * @param string $storeId
     */
    public function __construct($availableQty = null, $storeDescription = null, $storeId = null)
    {
        $this
            ->setAvailableQty($availableQty)
            ->setStoreDescription($storeDescription)
            ->setStoreId($storeId);
    }
    /**
     * Get AvailableQty value
     * @return float|null
     */
    public function getAvailableQty()
    {
        return $this->AvailableQty;
    }
    /**
     * Set AvailableQty value
     * @param float $availableQty
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\AvailableQtyByStore
     */
    public function setAvailableQty($availableQty = null)
    {
        // validation for constraint: float
        if (!is_null($availableQty) && !(is_float($availableQty) || is_numeric($availableQty))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($availableQty, true), gettype($availableQty)), __LINE__);
        }
        $this->AvailableQty = $availableQty;
        return $this;
    }
    /**
     * Get StoreDescription value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getStoreDescription()
    {
        return isset($this->StoreDescription) ? $this->StoreDescription : null;
    }
    /**
     * Set StoreDescription value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $storeDescription
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\AvailableQtyByStore
     */
    public function setStoreDescription($storeDescription = null)
    {
        // validation for constraint: string
        if (!is_null($storeDescription) && !is_string($storeDescription)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($storeDescription, true), gettype($storeDescription)), __LINE__);
        }
        if (is_null($storeDescription) || (is_array($storeDescription) && empty($storeDescription))) {
            unset($this->StoreDescription);
        } else {
            $this->StoreDescription = $storeDescription;
        }
        return $this;
    }
    /**
     * Get StoreId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getStoreId()
    {
        return isset($this->StoreId) ? $this->StoreId : null;
    }
    /**
     * Set StoreId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $storeId
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\AvailableQtyByStore
     */
    public function setStoreId($storeId = null)
    {
        // validation for constraint: string
        if (!is_null($storeId) && !is_string($storeId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($storeId, true), gettype($storeId)), __LINE__);
        }
        if (is_null($storeId) || (is_array($storeId) && empty($storeId))) {
            unset($this->StoreId);
        } else {
            $this->StoreId = $storeId;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\AvailableQtyByStore
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
