<?php

namespace FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetAvailableCumulativeQtyAllStoresResponse StructType
 * Meta information extracted from the WSDL
 * - documentation: Renvoie le cumul des quantités disponibles en stock de tous les établissements accessibles à l’utilisateur courant.
 * @subpackage Structs
 */
class GetAvailableCumulativeQtyAllStoresResponse extends AbstractStructBase
{
    /**
     * The GetAvailableCumulativeQtyAllStoresResult
     * Meta information extracted from the WSDL
     * - documentation: Renvoie un objet contenant à la fois le cumul des quantité disponible en stock et le status de la recherche des dépôts. Si aucun dépôt n'a pu être déterminé, la quantité cumulée vaut 0.
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\AvailableQtyReturn
     */
    public $GetAvailableCumulativeQtyAllStoresResult;
    /**
     * Constructor method for GetAvailableCumulativeQtyAllStoresResponse
     * @uses GetAvailableCumulativeQtyAllStoresResponse::setGetAvailableCumulativeQtyAllStoresResult()
     * @param \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\AvailableQtyReturn $getAvailableCumulativeQtyAllStoresResult
     */
    public function __construct(\FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\AvailableQtyReturn $getAvailableCumulativeQtyAllStoresResult = null)
    {
        $this
            ->setGetAvailableCumulativeQtyAllStoresResult($getAvailableCumulativeQtyAllStoresResult);
    }
    /**
     * Get GetAvailableCumulativeQtyAllStoresResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\AvailableQtyReturn|null
     */
    public function getGetAvailableCumulativeQtyAllStoresResult()
    {
        return isset($this->GetAvailableCumulativeQtyAllStoresResult) ? $this->GetAvailableCumulativeQtyAllStoresResult : null;
    }
    /**
     * Set GetAvailableCumulativeQtyAllStoresResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\AvailableQtyReturn $getAvailableCumulativeQtyAllStoresResult
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetAvailableCumulativeQtyAllStoresResponse
     */
    public function setGetAvailableCumulativeQtyAllStoresResult(\FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\AvailableQtyReturn $getAvailableCumulativeQtyAllStoresResult = null)
    {
        if (is_null($getAvailableCumulativeQtyAllStoresResult) || (is_array($getAvailableCumulativeQtyAllStoresResult) && empty($getAvailableCumulativeQtyAllStoresResult))) {
            unset($this->GetAvailableCumulativeQtyAllStoresResult);
        } else {
            $this->GetAvailableCumulativeQtyAllStoresResult = $getAvailableCumulativeQtyAllStoresResult;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetAvailableCumulativeQtyAllStoresResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
