<?php

namespace FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetInventoryDetailByStoreResponse StructType
 * Meta information extracted from the WSDL
 * - documentation: Renvoie le détail par établissement de la quantité disponible en stock pour un article sans dimension ou SKU.
 * @subpackage Structs
 */
class GetInventoryDetailByStoreResponse extends AbstractStructBase
{
    /**
     * The GetInventoryDetailByStoreResult
     * Meta information extracted from the WSDL
     * - documentation: Renvoie une liste d'associations établissement - quantité disponible. Si aucun établissement n'est ouvert ou si l'article est inconnu, renvoie une liste vide.
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\ItemInventoryWcfService\ArrayType\ArrayOfAvailableQtyByStore
     */
    public $GetInventoryDetailByStoreResult;
    /**
     * Constructor method for GetInventoryDetailByStoreResponse
     * @uses GetInventoryDetailByStoreResponse::setGetInventoryDetailByStoreResult()
     * @param \FiloBlu\CegidY2\Api\ItemInventoryWcfService\ArrayType\ArrayOfAvailableQtyByStore $getInventoryDetailByStoreResult
     */
    public function __construct(\FiloBlu\CegidY2\Api\ItemInventoryWcfService\ArrayType\ArrayOfAvailableQtyByStore $getInventoryDetailByStoreResult = null)
    {
        $this
            ->setGetInventoryDetailByStoreResult($getInventoryDetailByStoreResult);
    }
    /**
     * Get GetInventoryDetailByStoreResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\ArrayType\ArrayOfAvailableQtyByStore|null
     */
    public function getGetInventoryDetailByStoreResult()
    {
        return isset($this->GetInventoryDetailByStoreResult) ? $this->GetInventoryDetailByStoreResult : null;
    }
    /**
     * Set GetInventoryDetailByStoreResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\ItemInventoryWcfService\ArrayType\ArrayOfAvailableQtyByStore $getInventoryDetailByStoreResult
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetInventoryDetailByStoreResponse
     */
    public function setGetInventoryDetailByStoreResult(\FiloBlu\CegidY2\Api\ItemInventoryWcfService\ArrayType\ArrayOfAvailableQtyByStore $getInventoryDetailByStoreResult = null)
    {
        if (is_null($getInventoryDetailByStoreResult) || (is_array($getInventoryDetailByStoreResult) && empty($getInventoryDetailByStoreResult))) {
            unset($this->GetInventoryDetailByStoreResult);
        } else {
            $this->GetInventoryDetailByStoreResult = $getInventoryDetailByStoreResult;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetInventoryDetailByStoreResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
