<?php

namespace FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UpdatePointsRequest StructType
 * Meta information extracted from the WSDL
 * - documentation: Input parameters to provide for updating loyalty points
 * - nillable: true
 * - type: tns:UpdatePointsRequest
 * @subpackage Structs
 */
class UpdatePointsRequest extends AbstractStructBase
{
    /**
     * The Comment
     * Meta information extracted from the WSDL
     * - documentation: [Optional] - Free text comment. - Related to column [MCARTEFIDLIG.MFL_COMMENTAIRE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Comment;
    /**
     * The Date
     * Meta information extracted from the WSDL
     * - documentation: Movement date. - Related to column [MCARTEFIDLIG.MFL_DATEVENTE].
     * - minOccurs: 0
     * @var string
     */
    public $Date;
    /**
     * The LineType
     * Meta information extracted from the WSDL
     * - documentation: Line type. - Related to column [MCARTEFIDLIG.MFL_TYPELIGNEFIDEL2].
     * - minOccurs: 0
     * @var string
     */
    public $LineType;
    /**
     * The LoyaltyCardId
     * Meta information extracted from the WSDL
     * - documentation: Identifier of the loyalty card. - Related to column [MCARTEFIDENT.MFC_NUMCARTE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $LoyaltyCardId;
    /**
     * The Points
     * Meta information extracted from the WSDL
     * - documentation: Number of points. If the value is higher than the maximum authorized (as set in the reason), the update will be rejected. - Related to column [MCARTEFIDLIG.MFL_VALEURDISPO].
     * - minOccurs: 0
     * @var float
     */
    public $Points;
    /**
     * The ProgramId
     * Meta information extracted from the WSDL
     * - documentation: Loyalty card program ID. - Related to column [MCARTEFIDLIG.MFL_PROGFIDELITE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ProgramId;
    /**
     * The ReasonId
     * Meta information extracted from the WSDL
     * - documentation: Reason for modifying the counter or adding a line. - Related to column [MCARTEFIDLIG.MFL_MOTIFFID].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ReasonId;
    /**
     * The StoreId
     * Meta information extracted from the WSDL
     * - documentation: Store identifier. - Related to column [MCARTEFIDLIG.MFL_ETABLISSEMENT].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $StoreId;
    /**
     * Constructor method for UpdatePointsRequest
     * @uses UpdatePointsRequest::setComment()
     * @uses UpdatePointsRequest::setDate()
     * @uses UpdatePointsRequest::setLineType()
     * @uses UpdatePointsRequest::setLoyaltyCardId()
     * @uses UpdatePointsRequest::setPoints()
     * @uses UpdatePointsRequest::setProgramId()
     * @uses UpdatePointsRequest::setReasonId()
     * @uses UpdatePointsRequest::setStoreId()
     * @param string $comment
     * @param string $date
     * @param string $lineType
     * @param string $loyaltyCardId
     * @param float $points
     * @param string $programId
     * @param string $reasonId
     * @param string $storeId
     */
    public function __construct($comment = null, $date = null, $lineType = null, $loyaltyCardId = null, $points = null, $programId = null, $reasonId = null, $storeId = null)
    {
        $this
            ->setComment($comment)
            ->setDate($date)
            ->setLineType($lineType)
            ->setLoyaltyCardId($loyaltyCardId)
            ->setPoints($points)
            ->setProgramId($programId)
            ->setReasonId($reasonId)
            ->setStoreId($storeId);
    }
    /**
     * Get Comment value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getComment()
    {
        return isset($this->Comment) ? $this->Comment : null;
    }
    /**
     * Set Comment value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $comment
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\UpdatePointsRequest
     */
    public function setComment($comment = null)
    {
        // validation for constraint: string
        if (!is_null($comment) && !is_string($comment)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($comment, true), gettype($comment)), __LINE__);
        }
        if (is_null($comment) || (is_array($comment) && empty($comment))) {
            unset($this->Comment);
        } else {
            $this->Comment = $comment;
        }
        return $this;
    }
    /**
     * Get Date value
     * @return string|null
     */
    public function getDate()
    {
        return $this->Date;
    }
    /**
     * Set Date value
     * @param string $date
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\UpdatePointsRequest
     */
    public function setDate($date = null)
    {
        // validation for constraint: string
        if (!is_null($date) && !is_string($date)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($date, true), gettype($date)), __LINE__);
        }
        $this->Date = $date;
        return $this;
    }
    /**
     * Get LineType value
     * @return string|null
     */
    public function getLineType()
    {
        return $this->LineType;
    }
    /**
     * Set LineType value
     * @uses \FiloBlu\CegidY2\Api\LoyaltyWcfService\EnumType\UpdatePointsLineType::valueIsValid()
     * @uses \FiloBlu\CegidY2\Api\LoyaltyWcfService\EnumType\UpdatePointsLineType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $lineType
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\UpdatePointsRequest
     */
    public function setLineType($lineType = null)
    {
        // validation for constraint: enumeration
        if (!\FiloBlu\CegidY2\Api\LoyaltyWcfService\EnumType\UpdatePointsLineType::valueIsValid($lineType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \FiloBlu\CegidY2\Api\LoyaltyWcfService\EnumType\UpdatePointsLineType', is_array($lineType) ? implode(', ', $lineType) : var_export($lineType, true), implode(', ', \FiloBlu\CegidY2\Api\LoyaltyWcfService\EnumType\UpdatePointsLineType::getValidValues())), __LINE__);
        }
        $this->LineType = $lineType;
        return $this;
    }
    /**
     * Get LoyaltyCardId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLoyaltyCardId()
    {
        return isset($this->LoyaltyCardId) ? $this->LoyaltyCardId : null;
    }
    /**
     * Set LoyaltyCardId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $loyaltyCardId
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\UpdatePointsRequest
     */
    public function setLoyaltyCardId($loyaltyCardId = null)
    {
        // validation for constraint: string
        if (!is_null($loyaltyCardId) && !is_string($loyaltyCardId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($loyaltyCardId, true), gettype($loyaltyCardId)), __LINE__);
        }
        if (is_null($loyaltyCardId) || (is_array($loyaltyCardId) && empty($loyaltyCardId))) {
            unset($this->LoyaltyCardId);
        } else {
            $this->LoyaltyCardId = $loyaltyCardId;
        }
        return $this;
    }
    /**
     * Get Points value
     * @return float|null
     */
    public function getPoints()
    {
        return $this->Points;
    }
    /**
     * Set Points value
     * @param float $points
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\UpdatePointsRequest
     */
    public function setPoints($points = null)
    {
        // validation for constraint: float
        if (!is_null($points) && !(is_float($points) || is_numeric($points))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($points, true), gettype($points)), __LINE__);
        }
        $this->Points = $points;
        return $this;
    }
    /**
     * Get ProgramId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getProgramId()
    {
        return isset($this->ProgramId) ? $this->ProgramId : null;
    }
    /**
     * Set ProgramId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $programId
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\UpdatePointsRequest
     */
    public function setProgramId($programId = null)
    {
        // validation for constraint: string
        if (!is_null($programId) && !is_string($programId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($programId, true), gettype($programId)), __LINE__);
        }
        if (is_null($programId) || (is_array($programId) && empty($programId))) {
            unset($this->ProgramId);
        } else {
            $this->ProgramId = $programId;
        }
        return $this;
    }
    /**
     * Get ReasonId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getReasonId()
    {
        return isset($this->ReasonId) ? $this->ReasonId : null;
    }
    /**
     * Set ReasonId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $reasonId
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\UpdatePointsRequest
     */
    public function setReasonId($reasonId = null)
    {
        // validation for constraint: string
        if (!is_null($reasonId) && !is_string($reasonId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($reasonId, true), gettype($reasonId)), __LINE__);
        }
        if (is_null($reasonId) || (is_array($reasonId) && empty($reasonId))) {
            unset($this->ReasonId);
        } else {
            $this->ReasonId = $reasonId;
        }
        return $this;
    }
    /**
     * Get StoreId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getStoreId()
    {
        return isset($this->StoreId) ? $this->StoreId : null;
    }
    /**
     * Set StoreId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $storeId
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\UpdatePointsRequest
     */
    public function setStoreId($storeId = null)
    {
        // validation for constraint: string
        if (!is_null($storeId) && !is_string($storeId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($storeId, true), gettype($storeId)), __LINE__);
        }
        if (is_null($storeId) || (is_array($storeId) && empty($storeId))) {
            unset($this->StoreId);
        } else {
            $this->StoreId = $storeId;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\UpdatePointsRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
