<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfUpdate_Payment ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfUpdate_Payment
 * @subpackage Arrays
 */
class ArrayOfUpdate_Payment extends AbstractStructArrayBase
{
    /**
     * The Update_Payment
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Payment[]
     */
    public $Update_Payment;
    /**
     * Constructor method for ArrayOfUpdate_Payment
     * @uses ArrayOfUpdate_Payment::setUpdate_Payment()
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Payment[] $update_Payment
     */
    public function __construct(array $update_Payment = array())
    {
        $this
            ->setUpdate_Payment($update_Payment);
    }
    /**
     * Get Update_Payment value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Payment[]|null
     */
    public function getUpdate_Payment()
    {
        return isset($this->Update_Payment) ? $this->Update_Payment : null;
    }
    /**
     * This method is responsible for validating the values passed to the setUpdate_Payment method
     * This method is willingly generated in order to preserve the one-line inline validation within the setUpdate_Payment method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateUpdate_PaymentForArrayConstraintsFromSetUpdate_Payment(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfUpdate_PaymentUpdate_PaymentItem) {
            // validation for constraint: itemType
            if (!$arrayOfUpdate_PaymentUpdate_PaymentItem instanceof \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Payment) {
                $invalidValues[] = is_object($arrayOfUpdate_PaymentUpdate_PaymentItem) ? get_class($arrayOfUpdate_PaymentUpdate_PaymentItem) : sprintf('%s(%s)', gettype($arrayOfUpdate_PaymentUpdate_PaymentItem), var_export($arrayOfUpdate_PaymentUpdate_PaymentItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Update_Payment property can only contain items of type \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Payment, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Update_Payment value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Payment[] $update_Payment
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUpdate_Payment
     */
    public function setUpdate_Payment(array $update_Payment = array())
    {
        // validation for constraint: array
        if ('' !== ($update_PaymentArrayErrorMessage = self::validateUpdate_PaymentForArrayConstraintsFromSetUpdate_Payment($update_Payment))) {
            throw new \InvalidArgumentException($update_PaymentArrayErrorMessage, __LINE__);
        }
        if (is_null($update_Payment) || (is_array($update_Payment) && empty($update_Payment))) {
            unset($this->Update_Payment);
        } else {
            $this->Update_Payment = $update_Payment;
        }
        return $this;
    }
    /**
     * Add item to Update_Payment value
     * @throws \InvalidArgumentException
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Payment $item
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUpdate_Payment
     */
    public function addToUpdate_Payment(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Payment $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Payment) {
            throw new \InvalidArgumentException(sprintf('The Update_Payment property can only contain items of type \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Payment, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Update_Payment[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Payment|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Payment|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Payment|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Payment|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Payment|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Update_Payment
     */
    public function getAttributeName()
    {
        return 'Update_Payment';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUpdate_Payment
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
