<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CustomersReservationCreate StructType
 * Meta information extracted from the WSDL
 * - documentation: [Added 2014/05 - V1110] [Beta] - Enables the creation of a customer reservation.
 * @subpackage Structs
 */
class CustomersReservationCreate extends AbstractStructBase
{
    /**
     * The customersReservationCreateRequest
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Request
     */
    public $customersReservationCreateRequest;
    /**
     * The clientContext
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\RetailContext
     */
    public $clientContext;
    /**
     * Constructor method for CustomersReservationCreate
     * @uses CustomersReservationCreate::setCustomersReservationCreateRequest()
     * @uses CustomersReservationCreate::setClientContext()
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Request $customersReservationCreateRequest
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\RetailContext $clientContext
     */
    public function __construct(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Request $customersReservationCreateRequest = null, \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\RetailContext $clientContext = null)
    {
        $this
            ->setCustomersReservationCreateRequest($customersReservationCreateRequest)
            ->setClientContext($clientContext);
    }
    /**
     * Get customersReservationCreateRequest value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Request|null
     */
    public function getCustomersReservationCreateRequest()
    {
        return isset($this->customersReservationCreateRequest) ? $this->customersReservationCreateRequest : null;
    }
    /**
     * Set customersReservationCreateRequest value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Request $customersReservationCreateRequest
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate
     */
    public function setCustomersReservationCreateRequest(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Request $customersReservationCreateRequest = null)
    {
        if (is_null($customersReservationCreateRequest) || (is_array($customersReservationCreateRequest) && empty($customersReservationCreateRequest))) {
            unset($this->customersReservationCreateRequest);
        } else {
            $this->customersReservationCreateRequest = $customersReservationCreateRequest;
        }
        return $this;
    }
    /**
     * Get clientContext value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\RetailContext|null
     */
    public function getClientContext()
    {
        return isset($this->clientContext) ? $this->clientContext : null;
    }
    /**
     * Set clientContext value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\RetailContext $clientContext
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate
     */
    public function setClientContext(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\RetailContext $clientContext = null)
    {
        if (is_null($clientContext) || (is_array($clientContext) && empty($clientContext))) {
            unset($this->clientContext);
        } else {
            $this->clientContext = $clientContext;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
