<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UpdatePayments StructType
 * Meta information extracted from the WSDL
 * - documentation: [Added 2013/04 - V1105] - Enables the modification of payments for a sales document.
 * @subpackage Structs
 */
class UpdatePayments extends AbstractStructBase
{
    /**
     * The updatePaymentsRequest
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UpdatePayments_Request
     */
    public $updatePaymentsRequest;
    /**
     * The clientContext
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\RetailContext
     */
    public $clientContext;
    /**
     * Constructor method for UpdatePayments
     * @uses UpdatePayments::setUpdatePaymentsRequest()
     * @uses UpdatePayments::setClientContext()
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UpdatePayments_Request $updatePaymentsRequest
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\RetailContext $clientContext
     */
    public function __construct(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UpdatePayments_Request $updatePaymentsRequest = null, \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\RetailContext $clientContext = null)
    {
        $this
            ->setUpdatePaymentsRequest($updatePaymentsRequest)
            ->setClientContext($clientContext);
    }
    /**
     * Get updatePaymentsRequest value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UpdatePayments_Request|null
     */
    public function getUpdatePaymentsRequest()
    {
        return isset($this->updatePaymentsRequest) ? $this->updatePaymentsRequest : null;
    }
    /**
     * Set updatePaymentsRequest value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UpdatePayments_Request $updatePaymentsRequest
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UpdatePayments
     */
    public function setUpdatePaymentsRequest(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UpdatePayments_Request $updatePaymentsRequest = null)
    {
        if (is_null($updatePaymentsRequest) || (is_array($updatePaymentsRequest) && empty($updatePaymentsRequest))) {
            unset($this->updatePaymentsRequest);
        } else {
            $this->updatePaymentsRequest = $updatePaymentsRequest;
        }
        return $this;
    }
    /**
     * Get clientContext value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\RetailContext|null
     */
    public function getClientContext()
    {
        return isset($this->clientContext) ? $this->clientContext : null;
    }
    /**
     * Set clientContext value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\RetailContext $clientContext
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UpdatePayments
     */
    public function setClientContext(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\RetailContext $clientContext = null)
    {
        if (is_null($clientContext) || (is_array($clientContext) && empty($clientContext))) {
            unset($this->clientContext);
        } else {
            $this->clientContext = $clientContext;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UpdatePayments
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
