<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UpdatePayments_Request StructType
 * Meta information extracted from the WSDL
 * - documentation: List of payments to modify
 * - nillable: true
 * - type: tns:UpdatePayments_Request
 * @subpackage Structs
 */
class UpdatePayments_Request extends AbstractStructBase
{
    /**
     * The Identifier
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentIdentifier
     */
    public $Identifier;
    /**
     * The Payments
     * Meta information extracted from the WSDL
     * - documentation: List of payments.
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUpdate_Payment
     */
    public $Payments;
    /**
     * Constructor method for UpdatePayments_Request
     * @uses UpdatePayments_Request::setIdentifier()
     * @uses UpdatePayments_Request::setPayments()
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentIdentifier $identifier
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUpdate_Payment $payments
     */
    public function __construct(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentIdentifier $identifier = null, \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUpdate_Payment $payments = null)
    {
        $this
            ->setIdentifier($identifier)
            ->setPayments($payments);
    }
    /**
     * Get Identifier value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentIdentifier|null
     */
    public function getIdentifier()
    {
        return isset($this->Identifier) ? $this->Identifier : null;
    }
    /**
     * Set Identifier value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentIdentifier $identifier
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UpdatePayments_Request
     */
    public function setIdentifier(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentIdentifier $identifier = null)
    {
        if (is_null($identifier) || (is_array($identifier) && empty($identifier))) {
            unset($this->Identifier);
        } else {
            $this->Identifier = $identifier;
        }
        return $this;
    }
    /**
     * Get Payments value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUpdate_Payment|null
     */
    public function getPayments()
    {
        return isset($this->Payments) ? $this->Payments : null;
    }
    /**
     * Set Payments value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUpdate_Payment $payments
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UpdatePayments_Request
     */
    public function setPayments(\FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUpdate_Payment $payments = null)
    {
        if (is_null($payments) || (is_array($payments) && empty($payments))) {
            unset($this->Payments);
        } else {
            $this->Payments = $payments;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UpdatePayments_Request
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
